<template>
  <v-simple-table>
    <!-- <template v-slot:default>
      <thead>
        <tr>
          <th class="text-left">Name</th>
          <th class="text-left">Jan</th>
          <th class="text-left">Feb</th>
          <th class="text-left">Mar</th>
          <th class="text-left">Apr</th>
          <th class="text-left">May</th>
          <th class="text-left">Jun</th>
          <th class="text-left">Jul</th>
          <th class="text-left">Aug</th>
          <th class="text-left">Seb</th>
          <th class="text-left">Oct</th>
          <th class="text-left">Nov</th>
          <th class="text-left">Dec</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in desserts" :key="item.name">
          <td>{{ item.name }}</td>
          <td>{{ item.data[0] }}</td>
          <td>{{ item.data[1] }}</td>
          <td>{{ item.data[2] }}</td>
          <td>{{ item.data[3] }}</td>
          <td>{{ item.data[4] }}</td>
          <td>{{ item.data[5] }}</td>
          <td>{{ item.data[6] }}</td>
          <td>{{ item.data[7] }}</td>
          <td>{{ item.data[8] }}</td>
          <td>{{ item.data[9] }}</td>
          <td>{{ item.data[10] }}</td>
          <td>{{ item.data[11] }}</td>
        </tr>
      </tbody>
    </template> -->

    <v-data-table
      :headers="headers"
      :items="desserts"
      hide-default-footer
      multi-sort
      class="elevation-1"
    >
      <template #item.price[0]="{ item }">
        <v-chip :color="getColor(item.price[0])" dark small>
          <moneyFormat :getPrice="item.price[0]" />
        </v-chip>
      </template>
      <template #item.price[1]="{ item }">
        <v-chip :color="getColor(item.price[1])" dark small>
          <moneyFormat :getPrice="item.price[1]" />
        </v-chip>
      </template>
      <template #item.price[2]="{ item }">
        <v-chip :color="getColor(item.price[2])" dark small>
          <moneyFormat :getPrice="item.price[2]" />
        </v-chip>
      </template>
      <template #item.price[3]="{ item }">
        <v-chip :color="getColor(item.price[3])" dark small>
          <moneyFormat :getPrice="item.price[3]" />
        </v-chip>
      </template>
      <template #item.price[4]="{ item }">
        <v-chip :color="getColor(item.price[4])" dark small>
          <moneyFormat :getPrice="item.price[4]" />
        </v-chip>
      </template>
      <template #item.price[5]="{ item }">
        <v-chip :color="getColor(item.price[5])" dark small>
          <moneyFormat :getPrice="item.price[5]" />
        </v-chip>
      </template>
      <template #item.price[6]="{ item }">
        <v-chip :color="getColor(item.price[6])" dark small>
          <moneyFormat :getPrice="item.price[6]" />
        </v-chip>
      </template>
      <template #item.price[7]="{ item }">
        <v-chip :color="getColor(item.price[7])" dark small>
          <moneyFormat :getPrice="item.price[7]" />
        </v-chip>
      </template>
      <template #item.price[8]="{ item }">
        <v-chip :color="getColor(item.price[8])" dark small>
          <moneyFormat :getPrice="item.price[8]" />
        </v-chip>
      </template>
      <template #item.price[9]="{ item }">
        <v-chip :color="getColor(item.price[9])" dark small>
          <moneyFormat :getPrice="item.price[9]" />
        </v-chip>
      </template>
      <template #item.price[10]="{ item }">
        <v-chip :color="getColor(item.price[10])" dark small>
          <moneyFormat :getPrice="item.price[10]" />
        </v-chip>
      </template>
      <template #item.price[11]="{ item }">
        <v-chip :color="getColor(item.price[11])" dark small>
          <moneyFormat :getPrice="item.price[11]" />
        </v-chip>
      </template>
    </v-data-table>
  </v-simple-table>
</template>
<script>
import covertDate from '@/mixins/formateDate'
import moneyFormat from '@/components/functional/moneyFormat.vue'
import axios from 'axios'
export default {
  mixins: [covertDate],
  components: {
    moneyFormat,
  },
  data() {
    return {
      desserts: [],
      headers: [
        {
          text: 'รายการ',
          value: 'name',

          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ม.ค.',
          value: 'price[0]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ก.พ.',
          value: 'price[1]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'มี.ค.',
          value: 'price[2]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'เม.ย.',
          value: 'price[3]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'พ.ค.',
          value: 'price[4]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'มิ.ย',
          value: 'price[5]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ก.ค.',
          value: 'price[6]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ส.ค.',
          value: 'price[7]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ก.ย.',
          value: 'price[8]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ต.ค.',
          value: 'price[9]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'พ.ย.',
          value: 'price[10]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ธ.ค.',
          value: 'price[11]',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
      ],
    }
  },
  mounted() {
    this.getDataAxios()
  },
  watch: {
    getdashboardTime(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountWeek
      )
    },
  },
  methods: {
    async getDataAxios(
      timeVal = new Date(),
      expensestable = 0,
      expensestype = 0
    ) {
      if (expensestable) {
        const checkTime = timeVal

        const date = new Date(checkTime)
        const firstDay = new Date(date.getFullYear(), 0, 1)
        const lastDay = new Date(date.getFullYear(), 11, 31)

        const dayStart = firstDay.getTime()
        const dayEnd = lastDay.getTime()

        const dataRes = this.totalTypeMulti(expensestable, dayStart, dayEnd)
        const countTypeName = expensestype.map((x) => x.name).length

        const getArray = this.setArray(dataRes, countTypeName, 12)
        const getObject = this.setObject(getArray, expensestype, countTypeName)

        this.desserts = getObject
      }
    },
    setArray(objData, coutName, countMonth) {
      const arrayDeserts = new Array(coutName)
      for (let i = 0; i < arrayDeserts.length; i++) {
        arrayDeserts[i] = new Array(2)
      }

      for (let i = 0; i < coutName; i++) {
        for (let j = 0; j < countMonth; j++) {
          objData.forEach((res) => {
            let d = new Date(res.date)
            if (res.id - 1 == i) {
              if (d.getMonth() == j) {
                if (arrayDeserts[i][j] > 0) {
                  arrayDeserts[i][j] = arrayDeserts[i][j] + res.price
                } else {
                  arrayDeserts[i][j] = res.price
                }
              }
            }
          })
          if (arrayDeserts[i][j] == null) {
            arrayDeserts[i][j] = 0
          }
        }
      }
      return arrayDeserts
    },
    setObject(arrayData, typeName, countMonth) {
      let datasetts = []
      for (let i = 0; i < countMonth; i++) {
        const dataset = {
          name: typeName[i].name,
          price: arrayData[i],
        }
        datasetts = [...datasetts, dataset]
      }
      return datasetts
    },
    getColor(price) {
      if (price > 1000) return 'red'
      else if (price > 500) return 'orange'
      else if (price > 0) return 'green'
      else return '!none'
    },
  },
}
</script>
